package handler

import (
	"github.com/gin-gonic/gin"
	v1 "github.com/go-nunu/nunu-layout-advanced/api/v1"
	"github.com/go-nunu/nunu-layout-advanced/internal/service"
	"github.com/mcuadros/go-defaults"
	"net/http"
)

type WebLimitHandler struct {
	*Handler
	webLimitService service.WebLimitService
}

func NewWebLimitHandler(
	handler *Handler,
	webLimitService service.WebLimitService,
) *WebLimitHandler {
	return &WebLimitHandler{
		Handler:         handler,
		webLimitService: webLimitService,
	}
}

func (h *WebLimitHandler) GetWebLimit(ctx *gin.Context) {

}

func (h *WebLimitHandler) AddWebLimit(ctx *gin.Context) {
	req := new(v1.GeneralLimitRequireRequest)

	if err := ctx.ShouldBind(req); err != nil {
		v1.HandleError(ctx, http.StatusBadRequest, v1.ErrBadRequest, err.Error())
		return
	}
	defaults.SetDefaults(req)
	res, err := h.webLimitService.AddWebLimit(ctx, req)
	if err != nil {
		v1.HandleError(ctx, http.StatusInternalServerError, err, err.Error())
		return
	}
	v1.HandleSuccess(ctx, res)

}

func (h *WebLimitHandler) EditWebLimit(ctx *gin.Context) {
	req := new(v1.WebLimitSendRequest)

	if err := ctx.ShouldBind(req); err != nil {
		v1.HandleError(ctx, http.StatusBadRequest, v1.ErrBadRequest, err.Error())
		return
	}
	defaults.SetDefaults(req)
	err := h.webLimitService.UpdateWebLimit(ctx, req)
	if err != nil {
		v1.HandleError(ctx, http.StatusInternalServerError, err, err.Error())
		return
	}
	v1.HandleSuccess(ctx, nil)
}

func (h *WebLimitHandler) DeleteWebLimit(ctx *gin.Context) {
	req := new(v1.WebLimitDeleteRequest)

	if err := ctx.ShouldBind(req); err != nil {
		v1.HandleError(ctx, http.StatusBadRequest, v1.ErrBadRequest, err.Error())
		return
	}
	defaults.SetDefaults(req)
	res, err := h.webLimitService.DeleteWebLimit(ctx, req.WafWebLimitId)
	if err != nil {
		v1.HandleError(ctx, http.StatusInternalServerError, err, err.Error())
		return
	}
	v1.HandleSuccess(ctx, res)

}
